/*! 
    \file physics_engine.h
    \brief Definition of the ... singleton Class
    
*/

#ifndef _PHYSICS_ENGINE_H
#define _PHYSICS_ENGINE_H

#include "base_object.h"
#include "physics_connection.h"
#include "fields.h"

// Forward Declaration
template<class T> class tList;


//! A default singleton class.
class PhysicsEngine : public BaseObject {

 public:
  static PhysicsEngine* getInstance(void);
  virtual ~PhysicsEngine(void);

  void addConnection(PhysicsConnection* connection);
  void removeConnection(PhysicsConnection* connection);

  void tick(float dt);

 private:
  PhysicsEngine(void);
  static PhysicsEngine* singletonRef;

  tList<PhysicsConnection>* connections;

  
};



#endif /* _PHYSICS_ENGINE_H */
